## xir 1.3.2

=== debian/changelog ===
xir (1.3.2-1) unstable; urgency=low

  [ Punit Agrawal ]
  * Initial release. (Closes: #990738)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 06 Jul 2021 09:59:19 +0900

## xir 1.4

=== CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.9)
project(xir VERSION 1.4.0 LANGUAGES C CXX)

include(${CMAKE_SOURCE_DIR}/cmake/VitisCommon.cmake)

option(BUILD_CONTRIB "build contrib lib" OFF)
option(BUILD_TEST "build test bin" OFF)
option(BUILD_DOC "build documentation" OFF)
option(BUILD_PYTHON "build python interface" OFF)
option(INSTALL_HOME "install python lib in cmake install path" OFF)
option(INSTALL_USER "install python lib in user space" OFF)

find_package(unilog REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(Boost REQUIRED)
find_package(Protobuf REQUIRED)

add_subdirectory(src)
add_subdirectory(tools)

file(RELATIVE_PATH REL_INCLUDE_DIR
  ${CMAKE_INSTALL_PREFIX}/share/cmake/${PROJECT_NAME}
  ${CMAKE_INSTALL_PREFIX}/include)
set(CONF_INCLUDE_DIRS "\${${PROJECT_NAME}_CMAKE_DIR}/${REL_INCLUDE_DIR}")
configure_file(cmake/config.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  @ONLY)

write_basic_package_version_file(
  "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  DESTINATION share/cmake/${PROJECT_NAME})

if(BUILD_TEST)
  add_subdirectory(test)
endif()

if(BUILD_DOC)
  add_subdirectory(doc/doxygen)
endif(BUILD_DOC)

set(CPACK_PACKAGE_NAME "libxir")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Xilinx Intermediate Representation for deep learning algorithms")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/Copyright.txt")
set(CPACK_PACKAGE_VENDOR "Humanity")
set(CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${CMAKE_PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_PROJECT_VERSION_PATCH})
set(CPACK_PACKAGE_CONTACT "Jian Weng<jianweng@xilinx.com>")
set(CPACK_PACKAGING_INSTALL_PREFIX "/usr")

set(CPACK_DEB_COMPONENT_INSTALL OFF)
set(CPACK_DEBIAN_PACKAGE_SECTION "devel")
set(CPACK_DEBIAN_ARCHIVE_TYPE "gnutar")
set(CPACK_DEBIAN_COMPRESSION_TYPE "gzip")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libunilog (>=1.2.0)")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
if(DEFINED ENV{BUILD_NUMBER})
  set(CPACK_DEBIAN_PACKAGE_RELEASE "r$ENV{BUILD_NUMBER}")
endif()
if(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "arm64")
elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
else()
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
endif()

set(CPACK_RPM_COMPONENT_INSTALL OFF)
set(CPACK_RPM_PACKAGE_LICENSE "Apache")
set(CPACK_RPM_PACKAGE_GROUP "Development/Tools")
set(CPACK_RPM_COMPRESSION_TYPE "xz")
set(CPACK_RPM_PACKAGE_REQUIRES "libunilog >= 1.2.0")
set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
if(DEFINED ENV{BUILD_NUMBER})
  set(CPACK_RPM_PACKAGE_RELEASE "r$ENV{BUILD_NUMBER}")
endif()
set(CPACK_RPM_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
if(CMAKE_SYSTEM_PROCESSOR STREQUAL "cortexa72-cortexa53")
    set(CPACK_RPM_PACKAGE_ARCHITECTURE "aarch64")
endif()

include(CPack)

=== python/CMakeLists.txt ===
# Copyright 2019 Xilinx Inc.

# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at

# http://www.apache.org/licenses/LICENSE-2.0

# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.

vai_add_pybind11_module(wrapper MODULE_NAME xir wrapper/wrapper.cpp
                        wrapper/pyxir_error_code.cpp)
target_link_libraries(wrapper PRIVATE xir)
target_include_directories(wrapper PRIVATE ${CMAKE_SOURCE_DIR}/src)

=== debian/changelog ===
xir (1.4-2ubuntu1) jammy; urgency=medium

  * d/rules: add -Wno-error=deprecated-declarations to fix the build
    against OpenSSL 3.0

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 07 Dec 2021 16:19:24 +0100

xir (1.4-2build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Wed, 24 Nov 2021 12:27:00 +0100

xir (1.4-2) unstable; urgency=medium

  * Update d/control.
    Set arm64, armhf and amd64 supporting architecture.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 21 Oct 2021 11:43:54 +0900

xir (1.4-1) unstable; urgency=medium

  * New upstream released.
  * Add d/patches/Fix-FTBFS-with-Werror-range-loop-construct-Closes-99.patch.
    (Closes: #996583)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 21 Oct 2021 11:43:46 +0900

xir (1.3.2-2) unstable; urgency=medium

  * Fix build bug with recent versions of compiler (Closes: #996583)

 -- Punit Agrawal <punit@debian.org>  Tue, 19 Oct 2021 11:17:02 +0900

=== debian/control ===
Source: xir
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Punit Agrawal <punit@debian.org>
Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: cmake, debhelper-compat (= 13),
	libboost-dev,
	libprotobuf-dev,
	libssl-dev,
	libunilog-dev,
	protobuf-compiler
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/Xilinx/Vitis-AI
Vcs-Git: https://salsa.debian.org/xilinx-packages-team/vitis-ai/xir.git
Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/vitis-ai/xir

Package: libxir1
Architecture: amd64 arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Xilinx Intermediate Representation (XIR) for deep learning algorithms (runtime)
 Xilinx Intermediate Representation (XIR) is a graph based
 intermediate representation of the AI algorithms which is well
 designed for compilation and efficient deployment of the
 Domain-specific Processing Unit (DPU) on the FPGA platform. Advanced
 users can apply Whole Application Acceleration to benefit from the
 power of FPGA by extending the XIR to support customized IP in Vitis
 AI flow.
 .
 XIR includes Op, Tensor, Graph and Subgraph libraries, which
 providing a clear and flexible representation for the computational
 graph. For now, it's the foundation for the Vitis AI quantizer,
 compiler, runtime and many other tools. XIR provides in-memory
 format, and file format for different usage. The in-memory format XIR
 is a Graph object, and the file format is a xmodel. A Graph object
 can be serialized to a xmodel while the xmodel can be deserialized to
 the Graph object.
 .
 In the Op library, there's a well-defined set of operators to cover
 the wildly used deep learning frameworks, e.g. TensorFlow, Pytorch
 and Caffe, and all of the built-in operators for DPU. This enhences
 the expression ability and achieves one of the core goals of
 eliminating the difference between these frameworks and providing a
 unified representation for users and developers.
 .
 XIR also provides a Python APIs which is named PyXIR. It enables
 Python users to fully access XIR and benefits in a pure Python
 environment, e.g. co-develop and integrate users' Python project with
 the current XIR based tools without massive dirty work to fix the gap
 between two languages.
 .
 This package provides the runtime environment for XIR.

Package: libxir-dev
Architecture: amd64 arm64 armhf
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libxir1 (= ${binary:Version})
Description: Xilinx Intermediate Representation (XIR) for deep learning algorithms (develop)
 Xilinx Intermediate Representation (XIR) is a graph based
 intermediate representation of the AI algorithms which is well
 designed for compilation and efficient deployment of the
 Domain-specific Processing Unit (DPU) on the FPGA platform. Advanced
 users can apply Whole Application Acceleration to benefit from the
 power of FPGA by extending the XIR to support customized IP in Vitis
 AI flow.
 .
 XIR includes Op, Tensor, Graph and Subgraph libraries, which
 providing a clear and flexible representation for the computational
 graph. For now, it's the foundation for the Vitis AI quantizer,
 compiler, runtime and many other tools. XIR provides in-memory
 format, and file format for different usage. The in-memory format XIR
 is a Graph object, and the file format is a xmodel. A Graph object
 can be serialized to a xmodel while the xmodel can be deserialized to
 the Graph object.
 .
 In the Op library, there's a well-defined set of operators to cover
 the wildly used deep learning frameworks, e.g. TensorFlow, Pytorch
 and Caffe, and all of the built-in operators for DPU. This enhences
 the expression ability and achieves one of the core goals of
 eliminating the difference between these frameworks and providing a
 unified representation for users and developers.
 .
 XIR also provides a Python APIs which is named PyXIR. It enables
 Python users to fully access XIR and benefits in a pure Python
 environment, e.g. co-develop and integrate users' Python project with
 the current XIR based tools without massive dirty work to fix the gap
 between two languages.
 .
 This package provides the development environment for XIR.

Package: libxir-utils
Architecture: amd64 arm64 armhf
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}, libxir1 (= ${binary:Version})
Description: Xilinx Intermediate Representation (XIR) for deep learning algorithms (utils)
 Xilinx Intermediate Representation (XIR) is a graph based
 intermediate representation of the AI algorithms which is well
 designed for compilation and efficient deployment of the
 Domain-specific Processing Unit (DPU) on the FPGA platform. Advanced
 users can apply Whole Application Acceleration to benefit from the
 power of FPGA by extending the XIR to support customized IP in Vitis
 AI flow.
 .
 XIR includes Op, Tensor, Graph and Subgraph libraries, which
 providing a clear and flexible representation for the computational
 graph. For now, it's the foundation for the Vitis AI quantizer,
 compiler, runtime and many other tools. XIR provides in-memory
 format, and file format for different usage. The in-memory format XIR
 is a Graph object, and the file format is a xmodel. A Graph object
 can be serialized to a xmodel while the xmodel can be deserialized to
 the Graph object.
 .
 In the Op library, there's a well-defined set of operators to cover
 the wildly used deep learning frameworks, e.g. TensorFlow, Pytorch
 and Caffe, and all of the built-in operators for DPU. This enhences
 the expression ability and achieves one of the core goals of
 eliminating the difference between these frameworks and providing a
 unified representation for users and developers.
 .
 XIR also provides a Python APIs which is named PyXIR. It enables
 Python users to fully access XIR and benefits in a pure Python
 environment, e.g. co-develop and integrate users' Python project with
 the current XIR based tools without massive dirty work to fix the gap
 between two languages.
 .
 This package contains the utilities from XIR.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND  = -Wno-error=deprecated-declarations
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_FLAGS_DEBUG=""

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_ARGS)

override_dh_missing:
	dh_missing --list-missing

## xir 2.5

=== CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

cmake_minimum_required(VERSION 3.9)
project(
  xir
  VERSION 2.5.0
  LANGUAGES C CXX)

include(${PROJECT_SOURCE_DIR}/cmake/VitisCommon.cmake)

option(BUILD_CONTRIB "build contrib lib" OFF)
option(BUILD_TEST "build test bin" OFF)
option(BUILD_DOC "build documentation" OFF)
option(BUILD_PYTHON "build python interface" OFF)
option(INSTALL_HOME "install python lib in cmake install path" OFF)
option(INSTALL_USER "install python lib in user space" OFF)

# find_package(glog REQUIRED)
if(NOT TARGET unilog::unilog)
  find_package(unilog REQUIRED)
endif()

find_package(Boost REQUIRED)
find_package(Protobuf REQUIRED)
find_package(Threads REQUIRED)

add_subdirectory(src)
add_subdirectory(tools)

file(RELATIVE_PATH REL_INCLUDE_DIR
     ${CMAKE_INSTALL_PREFIX}/share/cmake/${PROJECT_NAME}
     ${CMAKE_INSTALL_PREFIX}/include)
set(CONF_INCLUDE_DIRS "\${${PROJECT_NAME}_CMAKE_DIR}/${REL_INCLUDE_DIR}")
configure_file(cmake/config.cmake.in
               "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake" @ONLY)

write_basic_package_version_file(
  "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
              "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
        DESTINATION share/cmake/${PROJECT_NAME})

if(BUILD_TEST)
  add_subdirectory(test)
endif()

if(BUILD_DOC)
  add_subdirectory(doc/doxygen)
endif(BUILD_DOC)

set(CPACK_PACKAGE_NAME "libxir")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY
    "Xilinx Intermediate Representation for deep learning algorithms")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/Copyright.txt")
set(CPACK_PACKAGE_VENDOR "Humanity")
set(CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${CMAKE_PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_PROJECT_VERSION_PATCH})
set(CPACK_PACKAGE_CONTACT "Jian Weng<jianweng@xilinx.com>")
set(CPACK_PACKAGING_INSTALL_PREFIX "/usr")

set(CPACK_DEB_COMPONENT_INSTALL OFF)
set(CPACK_DEBIAN_PACKAGE_SECTION "devel")
set(CPACK_DEBIAN_ARCHIVE_TYPE "gnutar")
set(CPACK_DEBIAN_COMPRESSION_TYPE "gzip")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libunilog (>=1.2.0)")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
if(DEFINED ENV{BUILD_NUMBER})
  set(CPACK_DEBIAN_PACKAGE_RELEASE "r$ENV{BUILD_NUMBER}")
endif()
if(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "arm64")
elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
else()
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
endif()

set(CPACK_RPM_COMPONENT_INSTALL OFF)
set(CPACK_RPM_PACKAGE_LICENSE "Apache")
set(CPACK_RPM_PACKAGE_GROUP "Development/Tools")
set(CPACK_RPM_COMPRESSION_TYPE "xz")
set(CPACK_RPM_PACKAGE_REQUIRES "libunilog >= 1.2.0")
set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
if(DEFINED ENV{BUILD_NUMBER})
  set(CPACK_RPM_PACKAGE_RELEASE "r$ENV{BUILD_NUMBER}")
endif()
set(CPACK_RPM_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
if(CMAKE_SYSTEM_PROCESSOR STREQUAL "cortexa72-cortexa53")
  set(CPACK_RPM_PACKAGE_ARCHITECTURE "aarch64")
endif()

include(CPack)

=== doxygen/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
include(FindDoxygen)

# doxygen setting
set(DOXYGEN_CONFIG_DIR ${PROJECT_SOURCE_DIR}/doc/doxygen)
configure_file(${DOXYGEN_CONFIG_DIR}/Doxyfile.in ${CMAKE_BINARY_DIR}/Doxyfile @ONLY)
add_custom_target(doc ALL
  COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
  COMMAND cp ${DOXYGEN_CONFIG_DIR}/Logo.png ${CMAKE_BINARY_DIR}/
  # optional, only necessary if you refer some images in your document.
  # COMMAND cp -av ${DOXYGEN_CONFIG_DIR}/images ${CMAKE_BINARY_DIR}/c-doc/latex
  COMMAND make -C ${CMAKE_BINARY_DIR}/c-doc/latex
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  COMMENT "Generating Documentation with Doxygen" VERBATIM
  )
install(FILES ${CMAKE_BINARY_DIR}/c-doc/latex/refman.pdf DESTINATION ${PROJECT_SOURCE_DIR}/doc
  RENAME xir-reference-manual.pdf)

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -14,5 +14,5 @@
 
 vai_add_pybind11_module(wrapper MODULE_NAME xir wrapper/wrapper.cpp
                         wrapper/pyxir_error_code.cpp)
-target_link_libraries(wrapper PRIVATE xir)
-target_include_directories(wrapper PRIVATE ${CMAKE_SOURCE_DIR}/src)
+target_link_libraries(wrapper PRIVATE xir unilog::unilog)
+target_include_directories(wrapper PRIVATE ${PROJECT_SOURCE_DIR}/src)

=== xir/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

include("${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/VitisVersion.cmake")

# get the git repo branch and commit id and write them into config.hpp
execute_process(
  COMMAND git rev-parse --abbrev-ref HEAD
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  OUTPUT_VARIABLE PROJECT_GIT_BRANCH_NAME
  OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(
  COMMAND git rev-parse HEAD
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  OUTPUT_VARIABLE PROJECT_GIT_COMMIT_ID
  OUTPUT_STRIP_TRAILING_WHITESPACE)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION
                                            VERSION_LESS 6.0)
  set(CMAKE_CXX_COMPILER_VERSION_LESS_THAN_6_0
      true
      CACHE BOOL "Use GNU C++ compiler and version is less than 6.0")
endif()
configure_file(config/config.hpp.in config.hpp @ONLY)

# run protoc
set(protobuf_MODULE_COMPATIBLE
    ON
    CACHE BOOL "")
file(GLOB_RECURSE PROTO_FILES proto/*.proto)
protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS EXPORT_MACRO XIR_DLLESPEC
                                                         ${PROTO_FILES})
if(MSVC)
  set_source_files_properties(
    ${PROTO_SRCS} PROPERTIES COMPILE_DEFINITIONS
                             "XIR_DLLESPEC=__declspec(dllexport)")
else(MSVC)
  set_source_files_properties(
    ${PROTO_SRCS}
    PROPERTIES COMPILE_DEFINITIONS
               "XIR_DLLESPEC=__attribute__((visibility(\"default\")))")
  set_source_files_properties(${PROTO_SRCS} PROPERTIES COMPILE_FLAGS
                                                       -Wno-unused-variable)
endif(MSVC)
aux_source_directory(util/ CPP_SRCS)
aux_source_directory(attrs/ CPP_SRCS)
aux_source_directory(op/ CPP_SRCS)
aux_source_directory(graph/ CPP_SRCS)
aux_source_directory(tensor/ CPP_SRCS)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/../../3rd-party/hash-library
                     CPP_SRCS)

add_library(${PROJECT_NAME} SHARED ${PROTO_SRCS} ${CPP_SRCS}
                                   ${CMAKE_CURRENT_BINARY_DIR}/version.c)
set_target_properties(
  ${PROJECT_NAME} PROPERTIES VERSION "${PROJECT_VERSION}"
                             SOVERSION "${PROJECT_VERSION_MAJOR}")
target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_17)
target_include_directories(
  ${PROJECT_NAME}
  PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:include>
  PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/util ${Boost_INCLUDE_DIRS}
          ${PROJECT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(
  xir
  PRIVATE protobuf::libprotobuf Threads::Threads ${CMAKE_DL_LIBS}
  PUBLIC unilog::unilog)
# Enable Export of public APIs
target_compile_definitions(${PROJECT_NAME} PRIVATE -DXIR_EXPORT)

install(
  TARGETS ${PROJECT_NAME}
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)
foreach(
  PUBLIC_HEADER
  xir/XirExport.hpp
  xir/op/op.hpp
  xir/op/op_def.hpp
  xir/attrs/attrs.hpp
  xir/attrs/attr_def.hpp
  xir/attrs/attr_expander.hpp
  xir/util/any.hpp
  xir/util/tool_function.hpp
  xir/util/data_type.hpp
  xir/graph/graph.hpp
  xir/graph/graph_template.hpp
  xir/graph/subgraph.hpp
  xir/tensor/tensor.hpp)
  get_filename_component(HEADER_PATH ${PUBLIC_HEADER} DIRECTORY)
  install(FILES ${PROJECT_SOURCE_DIR}/include/${PUBLIC_HEADER}
          DESTINATION include/${HEADER_PATH})
endforeach()
install(
  EXPORT ${PROJECT_NAME}-targets
  NAMESPACE ${PROJECT_NAME}::
  DESTINATION share/cmake/${PROJECT_NAME})

=== debian/changelog ===
xir (2.5-1) unstable; urgency=medium

  * New upstream release.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 03 Aug 2022 16:38:14 +0900

xir (2.0-1) experimental; urgency=medium

  * New upstream release.
  * Update soname to 2.
  * Update d/patches.
    - Remove Fix-FTBFS-with-Werror-range-loop-construct-Closes-99.patch.
    - Refresh patches.
  * Update d/control.
    - Bump Standards-Version to 4.6.0.1.
  * Update d/rules
    - Drop DEB_LDFLAGS_MAINT_APPEND.
      Fix lintian:debian-rules-uses-as-needed-linker-flag.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 07 Jun 2022 07:21:57 +0900

xir (1.4.1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Don't build with -Werror. (Closes: #1006582)

 -- Adrian Bunk <bunk@debian.org>  Sun, 22 May 2022 22:34:37 +0300

xir (1.4.1-5) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON via dh_auto_configure override.
    (Closes: #1005420)

  [ Punit Agrawal ]
  * Add a patch to remove build date from the embedded version
    (Closes: #1005421)

 -- Punit Agrawal <punit@debian.org>  Sun, 13 Feb 2022 16:36:14 +0900

xir (1.4.1-4) unstable; urgency=medium

  * Update d/control.
    - Change Maintainer and Uploaders. Set team email address to Maintainer.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 21 Jan 2022 04:35:15 +0900

xir (1.4.1-3) unstable; urgency=medium

  * Upload to unstable.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 20 Jan 2022 10:04:28 +0900

xir (1.4.1-2) experimental; urgency=medium

  * Update d/control:
      - Add armel to Support architecture.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 19 Jan 2022 11:42:49 +0900

xir (1.4.1-1) unstable; urgency=medium

  * New upstream released.
  * Update d/control
    - Update Maintainer and Uploaders.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 22 Dec 2021 20:45:12 +0900

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,23 @@
 Source: xir
+Maintainer: Debian Xilinx Package Maintainers <team+pkg-xilinx@tracker.debian.org>
+Uploaders: Punit Agrawal <punit@debian.org>,
+           Nobuhiro Iwamatsu <iwamatsu@debian.org>
+Priority: optional
 Section: libs
-Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Punit Agrawal <punit@debian.org>
-Uploaders: Nobuhiro Iwamatsu <iwamatsu@debian.org>
 Build-Depends: cmake, debhelper-compat (= 13),
 	libboost-dev,
 	libprotobuf-dev,
 	libssl-dev,
-	libunilog-dev,
+	libunilog-dev (>= 2.5),
 	protobuf-compiler
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/Xilinx/Vitis-AI
 Vcs-Git: https://salsa.debian.org/xilinx-packages-team/vitis-ai/xir.git
 Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/vitis-ai/xir
 
-Package: libxir1
-Architecture: amd64 arm64 armhf
+Package: libxir2
+Architecture: amd64 arm64 armhf armel
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Xilinx Intermediate Representation (XIR) for deep learning algorithms (runtime)
@@ -54,10 +54,10 @@
  This package provides the runtime environment for XIR.
 
 Package: libxir-dev
-Architecture: amd64 arm64 armhf
+Architecture: amd64 arm64 armhf armel
 Section: libdevel
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}, libxir1 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libxir2 (= ${binary:Version})
 Description: Xilinx Intermediate Representation (XIR) for deep learning algorithms (develop)
  Xilinx Intermediate Representation (XIR) is a graph based
  intermediate representation of the AI algorithms which is well
@@ -92,9 +92,9 @@
  This package provides the development environment for XIR.
 
 Package: libxir-utils
-Architecture: amd64 arm64 armhf
+Architecture: amd64 arm64 armhf armel
 Section: utils
-Depends: ${misc:Depends}, ${shlibs:Depends}, libxir1 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libxir2 (= ${binary:Version})
 Description: Xilinx Intermediate Representation (XIR) for deep learning algorithms (utils)
  Xilinx Intermediate Representation (XIR) is a graph based
  intermediate representation of the AI algorithms which is well

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Debug \
                 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
                 -DCMAKE_CXX_FLAGS_DEBUG="-std=c++17"

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_ARGS)

override_dh_missing:
	dh_missing --list-missing
